SOCKETPAIR(2)

NAME
socketpair - create a pair of connected sockets

SYNOPSIS
#include <sys/types.h>
#include <sys/socket.h>

int socketpair(d, type, protocol, sv)
int d, type, protocol;
int sv[2];

DESCRIPTION
The socketpair() system call creates an unnamed pair of connected sockets in the specified address family d, of the specified type and using the optionally specified protocol. The descriptors used in referencing the new sockets are returned in sv[0] and sv[1]. The two sockets are indistinguishable.

RETURN VALUES
socketpair() returns:

0   on success.

-1  on failure and sets errno to indicate the error.

ERRORS

EAFNOSUPPORT
    The specified address family is not supported on this machine.

EFAULT
    The address sv does not specify a valid part of the process address space.

EMFILE
    Too many descriptors are in use by this process.

EOPNOSUPPORT
    The specified protocol does not support creation of socket pairs.

EPROTONOSUPPORT
    The specified protocol is not supported on this machine.

SEE ALSO
pipe(2V), read(2V), write(2V)

BUGS
This call is currently implemented only for the AF_UNIX address family.